#ifndef MUTANT_H
#define MUTANT_H

#define MUT_POWER_ON 2
#define MUT_POWER_PRESENT 1
#define MUT_POWER_ABSENT 0

enum shMutantPower {
    kNoMutantPower = 0x0,
    /* Level 1 */
    kIllumination,
    kDigestion,
    kHypnosis,
    kRegeneration,
    kGammasensitivity,
    kPsiVomit,
    kDeepsight,
    /* Level 2 */
    kOpticBlast,
    kHaste,
    kTelepathyPower,
    kTremorsensePower,
    kShootWebs,
    kCharge,
    kWarFlow,
    /* Level 3 */
    kMentalBlast,
    kRestoration,
    kUnderstanding,
    kImbue,
    kKinesis,
    //kGravityCrush,
    kCauseFear,
    /* Level 4 */
    kAdrenalineControl,
    kXRayVisionPower,
    kTheVoice,
    //kSwordOfTheMind,
    //kSaltTheWound,
    /* Level 5 */
    kTeleport,
    kBGAwareness,
    kShockwave,
    //kCharm,
    //kMarkOfHate,
    /* Level 6 */
    kAutolysis,
    kFlightPower,
    //kGroundBurst,
    /* Level 8 */
    kPsionicStorm,
    //kStasisField,
/* monster only powers*/
    kHallucinate,
    kMaxHeroPower = kHallucinate,
    kTerrify,
    kDarkness,
    kMaxMutantPower = kDarkness,
    kCeaseAndDesist, /* lawyer first */
    kSeizeEvidence,
    kSueForDamages,
    kSummonWitness,  /* lawyer last */
    kLaunchMissile,  /* rocket turret */
    kMaxAllPower
};

struct shMutantPowerData {
    int mLevel;
    char mLetter;
    shAbilityIndex mAbility;
    shSkillCode mSkill;
    const char *mName;
    int (*mFunc) (shHero *);
    int (*mOffFunc) (shHero *);

    bool isPersistent (void);
    shSkillCode getCode (void);
};

extern shMutantPowerData MutantPowers[kMaxHeroPower];
const char *getMutantPowerName (shMutantPower id);

#endif
